jQuery(document).ready(function() { 	

	if (symposium.q == '&amp;') {
		symposium.q = '&';
	}

	// Get translated strings
	var areyousure = jQuery("#symposium_areyousure").html();
		
	/*
	   +------------------------------------------------------------------------------------------+
	   |                                        EVENTS                                            |
	   +------------------------------------------------------------------------------------------+
	*/
	
	// Act on default view on profile page being for Events
	if (symposium.view == 'wps_events' && symposium.embed == 'on') {

		jQuery('#profile_body').html("<img src='"+symposium.plugin_url+"/images/busy.gif' />"); 

		var menu_id = 'menu_events';
		var ajax_path = symposium.plugin_pro_url+"events/ajax/symposium_events_functions.php";

		jQuery.ajax({
			url: ajax_path, 
			type: "POST",
			data: ({
				action:menu_id,
				post:'',
				limit_from:0,
				uid1:symposium.current_user_page
			}),
		    dataType: "html",
			async: true,
			success: function(str){				
				jQuery('#profile_body').hide().html(str).fadeIn("slow");
			}
   		});
	}
	
	/* Show/hide edit and delete icons */
	jQuery('.symposium_event_list_item').live('mouseenter mouseleave', function(event) {
	  if (event.type == 'mouseenter') {
	        jQuery(this).find(".link_cursor").show();
	  } else {
	        jQuery(this).find(".link_cursor").hide();
	  }
	});

	/* Create button */
	jQuery("#symposium_create_event_button").live('click', function() {
		jQuery("#symposium_create_event_button").hide();
		jQuery("#symposium_events_list").hide();
		jQuery("#symposium_create_event_form").show();
		jQuery(".datepicker").datepicker({showButtonPanel: true});		
	});

	/* Cancel button */
	jQuery("#symposium_cancel_event_button").live('click', function() {
		jQuery("#symposium_create_event_button").show();
		jQuery("#symposium_events_list").show();
		jQuery("#symposium_create_event_form").hide();
	});

	/* Create (save) button */
	jQuery("#symposium_add_event_button").live('click', function() {
		var name = jQuery("#symposium_create_event_name").val().replace(/(<([^>]+)>)/ig, '');
		if (name == '') {
			jQuery("#symposium_create_event_name").css('border', '1px solid red').effect("highlight", {}, 4000);
		} else {
			// submit to database
			var desc = jQuery("#symposium_create_event_desc").val().replace(/(<([^>]+)>)/ig, '');
			var location = jQuery("#symposium_create_event_location").val().replace(/(<([^>]+)>)/ig, '');
			var start_date = jQuery("#event_start").val();
			var end_date = jQuery("#event_end").val();
			var start_hours = jQuery("#event_start_time_hours").val();
			var start_minutes = jQuery("#event_start_time_minutes").val();
			var end_hours = jQuery("#event_end_time_hours").val();
			var end_minutes = jQuery("#event_end_time_minutes").val();

			jQuery.ajax({
				url: symposium.plugin_pro_url+"events/ajax/symposium_events_functions.php", 
				type: "POST",
				data: ({
					action:"addEvent",
					'name':name,
					'desc':desc,
					'location':location,
					'start_date':start_date,
					'start_hours':start_hours,
					'start_minutes':start_minutes,
					'end_date':end_date,
					'end_hours':end_hours,
					'end_minutes':end_minutes
				}),
				dataType: "html",
				async: true,
				success: function(str){
					if (str == 'OK') {
						jQuery(".symposium_pleasewait").inmiddle().show();
						var reload_page = symposium.profile_url+symposium.q.substring(0, 1)+"uid="+symposium.current_user_page+"&embed=on&view=wps_events";
						window.location.href=reload_page;
					} else {
						alert(str);
					}
				},
				error: function(err){
					//alert("addEvent:"+err);
				}		
			});		
		}
	});
	
	/* Delete event */
	jQuery(".symposium_delete_event").live('click', function() {

	  	var answer = confirm(areyousure);
	  	if (answer) {
			var event_id = jQuery(this).attr("id");
			jQuery(this).parent().parent().slideUp("slow");

			jQuery.ajax({
				url: symposium.plugin_pro_url+"events/ajax/symposium_events_functions.php", 
				type: "POST",
				data: ({
					action:"deleteEvent",
					'eid':event_id
				}),
				dataType: "html",
				async: true,
				success: function(str){
					if (str != 'OK') {
						alert(str);
					}
				},
				error: function(err){
					//alert("deleteEvent:"+err);
				}		
			});		
		}
	});	

	// Edit event
	jQuery(".symposium_edit_event").live('click', function() {

		jQuery("#dialog").html("<img src='"+symposium.plugin_url+"/images/busy.gif' />");
		jQuery("#dialog").dialog({ title: 'Edit Event', width: 850, height: 550, modal: true, buttons: {}  });

		var event_id = jQuery(this).attr("id");

		jQuery.ajax({
			url: symposium.plugin_pro_url+"events/ajax/symposium_events_functions.php", 
			type: "POST",
			data: ({
				action:"editEvent",
				eid:event_id
			}),
			dataType: "html",
			async: false,
			success: function(str){
				var rows = jQuery.parseJSON(str);
				var html = '<div id="symposium_edit_event_eid" style="display:none">'+event_id+'</div>';
				html += '<div id="symposium_edit_event">';
		        jQuery.each(rows, function(i,row){
					html += "<input type='text' id='symposium_edit_event_name' class='symposium_edit_event_input' value='"+row.event_name.replace(/'/g, '&apos;')+"'><br /><br />";
					html += "<input type='text' id='symposium_edit_event_location' class='symposium_edit_event_input' value='"+row.event_location.replace(/'/g, '&apos;')+"'><br /><br />";
					html += "<textarea type='text' id='symposium_edit_event_desc' class='symposium_edit_event_textarea'>"+row.event_description.replace(/'/g, '&apos;')+"</textarea><br /><br />";
					html += '<div style="float:left;">';
						html += '<input type="text" id="symposium_edit_event_start" style="width:120px" class="datepicker" value="';
							if (row.start_date != '01/01/1970') { html += row.start_date };
							html += '" /> ';
						html += '<select id="symposium_edit_event_start_time_hours">';
						html += '<option value=99>-</option>';
					 	for(i=0;i<=23;i++){
							html += '<option value='+i;
							if (i==row.start_hours) { html += ' SELECTED'; }
							html += '>'+i+'</option>';
						}
						html += '</select> : ';
						html += '<select id="symposium_edit_event_start_time_minutes">';
						html += '<option value=99>-</option>';
					 	for(i=0;i<=3;i++){
							html += '<option value='+(i*15);
							if (i*15==row.start_minutes) { html += ' SELECTED'; }
							html += '>'+(i*15)+'</option>';
						}
						html += '</select>';
						html += ' &rarr; ';
						html += '<input type="text" id="symposium_edit_event_end" style="width:120px" class="datepicker" value="';
							if (row.end_date != '01/01/1970') { html += row.end_date };
							html += '" /> ';
						html += '<select id="symposium_edit_event_end_time_hours">';
						html += '<option value=99>-</option>';
					 	for(i=0;i<=23;i++){
							html += '<option value='+i;
							if (i==row.end_hours) { html += ' SELECTED'; }
							html += '>'+i+'</option>';
						}
						html += '</select> : ';
						html += '<select id="symposium_edit_event_end_time_minutes">';
						html += '<option value=99>-</option>';
					 	for(i=0;i<=3;i++){
							html += '<option value='+(i*15);
							if (i*15==row.end_minutes) { html += ' SELECTED'; }
							html += '>'+(i*15)+'</option>';
						}
						html += '</select>';
					html += '</div>';
					html += '<div style="clear: both; float: left; margin-top: 10px; margin-left:5px;">';
						html += '<input id="symposium_event_update_status" type="checkbox" ';
						if (row.event_live == 'on') { html += 'CHECKED'; }
						html += ' /> Live?';
					html += '</div>';
					html += '<div style="clear: both; float: left; margin-top: 10px; margin-left:5px;">';
						html += '<input id="event_google_map_status" type="checkbox" ';
						if (row.event_google_map == 'on') { html += 'CHECKED'; }
						html += ' /> Google Map?';
					html += '</div>';
					html += '<div style="clear: both; float: left; margin-top: 10px; margin-left:5px;">';
						html += '<input id="symposium_event_update_button" type="submit" class="symposium-button" value="Update" />';
						html += '<input id="symposium_event_cancel_button" type="submit" class="symposium-button" value="Cancel" />';
						html += '<div style="float: right;" id="symposium_edit_wait"></div>';
					html += '</div>';
				});
				html += '</div>';
				jQuery('#dialog').html(html);
				jQuery(".datepicker").datepicker({showButtonPanel: true});		
			},
			error: function(err){
				alert("deleteEvent:"+err);
			}		
		});		
   	});

	// Cancel event
	jQuery("#symposium_event_cancel_button").live('click', function() {
		jQuery("#dialog").dialog('close');
	});

	// Update event
	jQuery("#symposium_event_update_button").live('click', function() {

		jQuery(".symposium_pleasewait").inmiddle().show();

		var eid = jQuery('#symposium_edit_event_eid').html();
		var name = jQuery('#symposium_edit_event_name').val();
		var location = jQuery('#symposium_edit_event_location').val();
		var google_map = jQuery('#symposium_edit_event_location').val();
		var desc = jQuery('#symposium_edit_event_desc').val();
		var start = jQuery('#symposium_edit_event_start').val();
		var start_hours = jQuery('#symposium_edit_event_start_time_hours').find(':selected').val();
		var start_minutes = jQuery('#symposium_edit_event_start_time_minutes').find(':selected').val();
		var end = jQuery('#symposium_edit_event_end').val();
		var end_hours = jQuery('#symposium_edit_event_end_time_hours').find(':selected').val();
		var end_minutes = jQuery('#symposium_edit_event_end_time_minutes').find(':selected').val();
		var event_live = '';
		if (jQuery('#symposium_event_update_status:checked').val() == 'on') { event_live = 'on'; }
		var google_map = '';
		if (jQuery('#event_google_map_status:checked').val() == 'on') { google_map = 'on'; }

		jQuery.ajax({
			url: symposium.plugin_pro_url+"events/ajax/symposium_events_functions.php", 
			type: "POST",
			data: ({
				action:"updateEvent",
				'eid':eid,
				'name':name,
				'location':location,
				'google_map':google_map,
				'desc':desc,
				'start_date':start,
				'start_hours':start_hours,
				'start_minutes':start_minutes,
				'end_date':end,
				'end_hours':end_hours,
				'end_minutes':end_minutes,
				'event_live':event_live
			}),
			dataType: "html",
			async: true,
			success: function(str){
				if (str == 'OK') {
					var reload_page = symposium.profile_url+symposium.q.substring(0, 1)+"uid="+symposium.current_user_page+"&embed=on&view=wps_events";
					window.location.href=reload_page;
				} else {
					alert(str);
				}
			},
			error: function(err){
				//alert("updateEvent:"+err);
			}		
		});
		
	});
	
	
});



