<?php
/*
Plugin Name: WP Symposium Gallery
Plugin URI: http://www.wpsymposium.com
Description: Photo Albums for WP Symposium.
Version: 11.9.24
Author: WP Symposium
Author URI: http://www.wpsymposium.com
License: Commercial
Requires at least: WordPress 3.0 and WP Symposium 11.8.21
*/

define('WPS_GALLERY_VER', '11.9.24');
	
/*  Copyright 2011  Web Technology Solutions Ltd  (info@wpsymposium.com)

EULA stands for End User Licensing Agreement. This is the agreement through which the software is licensed to the software user. 

END-USER LICENSE AGREEMENT FOR WPS gallery 

IMPORTANT PLEASE READ THE TERMS AND CONDITIONS OF THIS LICENSE AGREEMENT CAREFULLY BEFORE CONTINUING WITH THIS PROGRAM 

INSTALL: Web Technology Solutions Ltd End-User License Agreement ("EULA") is a legal agreement between you (either an individual or a single entity) and Web Technology Solutions Ltd, for the software product(s) identified above which may include associated software components, media, printed materials, and "online" or electronic documentation ("SOFTWARE PRODUCT"). 

By installing, copying, or otherwise using the SOFTWARE PRODUCT, you agree to be bound by the terms of this EULA. This license agreement represents the entire agreement concerning the program between you and Web Technology Solutions Ltd, (referred to as "licenser"), and it supersedes any prior proposal, representation, or understanding between the parties. If you do not agree to the terms of this EULA, do not install or use the SOFTWARE PRODUCT.

The SOFTWARE PRODUCT is protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties. 

The SOFTWARE PRODUCT is licensed, not sold.

1. GRANT OF LICENSE. 
The SOFTWARE PRODUCT is licensed as follows: 
(a) Installation and Use.
Web Technology Solutions Ltd grants you the right to install and use copies of the SOFTWARE PRODUCT on your computer running a validly licensed copy of the operating system for which the SOFTWARE PRODUCT was designed.
(b) Backup Copies.
You may also make copies of the SOFTWARE PRODUCT as may be necessary for backup and archival purposes.

2. DESCRIPTION OF OTHER RIGHTS AND LIMITATIONS.
(a) Maintenance of Copyright Notices.
You must not remove or alter any copyright notices on any and all copies of the SOFTWARE PRODUCT.
(b) Distribution.
You may not distribute registered copies of the SOFTWARE PRODUCT to third parties. Evaluation versions available for download from Web Technology Solutions Ltd's websites may be freely distributed.
(c) Prohibition on Reverse Engineering, Decompilation, and Disassembly.
You may not reverse engineer, decompile, or disassemble the SOFTWARE PRODUCT, except and only to the extent that such activity is expressly permitted by applicable law notwithstanding this limitation. 
(d) Rental.
You may not rent, lease, or lend the SOFTWARE PRODUCT.
(e) Support Services.
Web Technology Solutions Ltd may provide you with support services related to the SOFTWARE PRODUCT ("Support Services"). Any supplemental software code provided to you as part of the Support Services shall be considered part of the SOFTWARE PRODUCT and subject to the terms and conditions of this EULA. 
(f) Compliance with Applicable Laws.
You must comply with all applicable laws regarding use of the SOFTWARE PRODUCT.

3. TERMINATION 
Without prejudice to any other rights, Web Technology Solutions Ltd may terminate this EULA if you fail to comply with the terms and conditions of this EULA. In such event, you must destroy all copies of the SOFTWARE PRODUCT in your possession.

4. COPYRIGHT
All title, including but not limited to copyrights, in and to the SOFTWARE PRODUCT and any copies thereof are owned by Web Technology Solutions Ltd or its suppliers. All title and intellectual property rights in and to the content which may be accessed through use of the SOFTWARE PRODUCT is the property of the respective content owner and may be protected by applicable copyright or other intellectual property laws and treaties. This EULA grants you no rights to use such content. All rights not expressly granted are reserved by Web Technology Solutions Ltd.

5. NO WARRANTIES
Web Technology Solutions Ltd expressly disclaims any warranty for the SOFTWARE PRODUCT. The SOFTWARE PRODUCT is provided 'As Is' without any express or implied warranty of any kind, including but not limited to any warranties of merchantability, noninfringement, or fitness of a particular purpose. Web Technology Solutions Ltd does not warrant or assume responsibility for the accuracy or completeness of any information, text, graphics, links or other items contained within the SOFTWARE PRODUCT. Web Technology Solutions Ltd makes no warranties respecting any harm that may be caused by the transmission of a computer virus, worm, time bomb, logic bomb, or other such computer program. Web Technology Solutions Ltd further expressly disclaims any warranty or representation to Authorized Users or to any third party.

6. LIMITATION OF LIABILITY
In no event shall Web Technology Solutions Ltd be liable for any damages (including, without limitation, lost profits, business interruption, or lost information) rising out of 'Authorized Users' use of or inability to use the SOFTWARE PRODUCT, even if Web Technology Solutions Ltd has been advised of the possibility of such damages. In no event will Web Technology Solutions Ltd be liable for loss of data or for indirect, special, incidental, consequential (including lost profit), or other damages based in contract, tort or otherwise. Web Technology Solutions Ltd shall have no liability with respect to the content of the SOFTWARE PRODUCT or any part thereof, including but not limited to errors or omissions contained therein, libel, infringements of rights of publicity, privacy, trademark rights, business interruption, personal injury, loss of privacy, moral rights or the disclosure of confidential information.

*/

// Main gallery function - tells WP Symposium that this plugin is activated
// For developers of additional plugins, this function is not necessary
function symposium_gallery(){}

/* ====================================================== ADMIN ====================================================== */

// Check for updates
if ( ( get_option("symposium_gallery_version") != WPS_GALLERY_VER && is_admin()) ) {

 	// Update Version *******************************************************************************
	update_option("symposium_gallery_version", WPS_GALLERY_VER);
	symposium_gallery_activate();	
}

function symposium_gallery_activate() {
	
	global $wpdb;

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    require_once(WP_PLUGIN_DIR . '/wp-symposium/symposium_functions.php');

	// Create gallery table
	$table_name = $wpdb->prefix . "symposium_gallery";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

		$sql = "CREATE TABLE " . $table_name . " (
		  gid int(11) NOT NULL AUTO_INCREMENT,
		  parent_gid int(11) NOT NULL DEFAULT 0,
		  name varchar(256) NOT NULL DEFAULT 'My album',
		  description text NOT NULL,
		  owner int(11) NOT NULL,
		  sharing varchar(16) NOT NULL DEFAULT 'friends',
		  editing varchar(16) NOT NULL DEFAULT 'owner',
		  created datetime NOT NULL,
		  updated datetime NOT NULL,
		  is_group varchar(2) NOT NULL,
		  PRIMARY KEY (gid)
		) CHARACTER SET utf8 COLLATE utf8_general_ci;";

	    dbDelta($sql);
	
	}

	// Create gallery item table
	$table_name = $wpdb->prefix . "symposium_gallery_items";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

		$sql = "CREATE TABLE " . $table_name . " (
		  iid int(11) NOT NULL AUTO_INCREMENT,
		  gid int(11),
		  owner int(11) NOT NULL,
		  name varchar(256) NOT NULL,
		  created datetime NOT NULL,
		  cover varchar(2) NOT NULL,
		  original MEDIUMBLOB NOT NULL,		  
		  photo MEDIUMBLOB NOT NULL,		  
		  thumbnail MEDIUMBLOB NOT NULL,
		  groupid int(11) NOT NULL,
		  title varchar(256) NOT NULL,
		  PRIMARY KEY (iid)
		) CHARACTER SET utf8 COLLATE utf8_general_ci;";

	    dbDelta($sql);	
	}
	
	// Create gallery comments
	$table_name = $wpdb->prefix . "symposium_gallery_comments";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

		$sql = "CREATE TABLE " . $table_name . " (
		  gcid int(11) NOT NULL AUTO_INCREMENT,
		  giid int(11) NOT NULL,
		  gid int(11) NOT NULL,
		  comment text NOT NULL,
		  owner int(11) NOT NULL,
		  PRIMARY KEY (gcid)
		) CHARACTER SET utf8 COLLATE utf8_general_ci;";

	    dbDelta($sql);
	
	}
	
}

function symposium_gallery_deactivate() {
}

function symposium_gallery_uninstall() {
	
   	global $wpdb;

   	$wpdb->query("DROP TABLE IF EXISTS ".$wpdb->prefix."symposium_gallery");
   	$wpdb->query("DROP TABLE IF EXISTS ".$wpdb->prefix."symposium_gallery_items");
   	$wpdb->query("DROP TABLE IF EXISTS ".$wpdb->prefix."symposium_gallery_comments");

}

register_activation_hook(__FILE__,'symposium_gallery_activate');
register_deactivation_hook(__FILE__, 'symposium_gallery_deactivate');
register_uninstall_hook(__FILE__, 'symposium_gallery_uninstall');

/* ====================================================== ADD PLUGIN JAVASCRIPT TO WORDPRESS ====================================================== */

function symposium_gallery_init()
{
	// Load Symposium Pro JS
 	wp_enqueue_script('symposium-gallery', WP_PLUGIN_URL.'/wp-symposium-gallery/js/symposium_gallery.js', array('jquery'));

    // Load CSS
    $myStyleUrl = WP_PLUGIN_URL . '/wp-symposium-gallery/css/symposium-gallery.css';
    $myStyleFile = WP_PLUGIN_DIR . '/wp-symposium-gallery/css/symposium-gallery.css';
    if ( file_exists($myStyleFile) ) {
        wp_register_style('symposium_gallery_StyleSheet', $myStyleUrl);
        wp_enqueue_style('symposium_gallery_StyleSheet');
    }

	// Load Colorbox JS
 	wp_enqueue_script('symposium-colorbox', WP_PLUGIN_URL.'/wp-symposium-gallery/js/jquery.colorbox.js', array('jquery'));

    // Load CSS
    $myStyleUrl = WP_PLUGIN_URL . '/wp-symposium-gallery/css/colorbox.css';
    $myStyleFile = WP_PLUGIN_DIR . '/wp-symposium-gallery/css/colorbox.css';
    if ( file_exists($myStyleFile) ) {
        wp_register_style('symposium_gallery_colorbox_StyleSheet', $myStyleUrl);
        wp_enqueue_style('symposium_gallery_colorbox_StyleSheet');
    }


}
add_action('init', 'symposium_gallery_init');

/* ===================================================================== WIDGETS ======================================================================== */

add_action( 'widgets_init', 'symposium_gallery_load_widgets' );

function symposium_gallery_load_widgets() {
	register_widget( 'Gallery_Widget' );
}

class Gallery_Widget extends WP_Widget {

	function Gallery_Widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'widget_gallery', 'description' => __('Shows albums that have had new items recently uploaded into them.', 'wp-symposium-gallery') );
		
		/* Widget control settings. */
		$control_ops = array( 'id_base' => 'gallery-widget' );
		
		/* Create the widget. */
		$this->WP_Widget( 'gallery-widget', 'Symposium: '.__('Gallery', 'wp-symposium-gallery'), $widget_ops, $control_ops );
	}
	
	// This is shown on the page
	function widget( $args, $instance ) {
		global $wpdb, $current_user;
		wp_get_current_user();
	
		extract( $args );
		
		// Work out link to profile page, dealing with permalinks or not
		$profile_url = symposium_get_url('profile');
		if (strpos($profile_url, '?') !== FALSE) {
			$q = "&";
		} else {
			$q = "?";
		}
		
		// Get options
		$wtitle = apply_filters('widget_title', $instance['wtitle'] );
		$albumcount = apply_filters('widget_postcount', $instance['albumcount'] );
		$shown_aid = "";
		$shown_count = 0;
		
		// Start widget
		echo $before_widget;
		echo $before_title . $wtitle . $after_title;
		
		// Content of widget
		$sql = "SELECT * FROM ".$wpdb->prefix."symposium_gallery g INNER JOIN ".$wpdb->base_prefix."users u ON g.owner = u.ID WHERE is_group != 'on' ORDER BY updated DESC LIMIT 0,50";
		$albums = $wpdb->get_results($sql);
			
		if ($albums) {

			echo "<div id='symposium_gallery_recent_activity'>";
				
				foreach ($albums as $album)
				{
					if ($shown_count < $albumcount) {

						if (strpos($shown_aid, $album->gid.",") === FALSE) { 

							if ( (strtolower($album->sharing) == 'everyone') || (strtolower($album->sharing) == 'friends only' && symposium_friend_of($album->owner)) ) {

								echo "<div class='symposium_gallery_recent_activity_row'>";		
									echo "<div class='symposium_gallery_recent_activity_row_avatar'>";
										echo get_avatar($album->owner, 32);
									echo "</div>";
									echo "<div class='symposium_gallery_recent_activity_row_post'>";
     									$text = __('added to ', 'wp-symposium-gallery')." <a href='".$profile_url.$q."uid=".$album->owner."&embed=on&album_id=".$album->gid."'>".stripslashes($album->name)."</a>";
										echo "<a href='".$profile_url.$q."uid=".$album->owner."'>".$album->display_name."</a> ".$text." ".symposium_time_ago($album->updated);
									echo "</div>";
								echo "</div>";
							
								$shown_count++;
								$shown_aid .= $album->gid.",";							
							}
						}
					} else {
						break;
					}
				}

			echo "</div>";

		}
		
		// End content
		
		echo $after_widget;
		// End widget
	}
	
	// This updates the stored values
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		
		/* Strip tags (if needed) and update the widget settings. */
		$instance['wtitle'] = strip_tags( $new_instance['wtitle'] );
		$instance['albumcount'] = strip_tags( $new_instance['albumcount'] );
		return $instance;
	}
	
	// This is the admin form for the widget
	function form( $instance ) {

		/* Set up some default widget settings. */
		$defaults = array( 'wtitle' => 'Recent photos', 'albumcount' => '5' );
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>

		<p>
			<label for="<?php echo $this->get_field_id( 'wtitle' ); ?>"><?php echo __('Widget Title', 'wp-symposium-gallery'); ?>:</label>
			<input id="<?php echo $this->get_field_id( 'wtitle' ); ?>" name="<?php echo $this->get_field_name( 'wtitle' ); ?>" value="<?php echo $instance['wtitle']; ?>" />
		<br /><br />
			<label for="<?php echo $this->get_field_id( 'albumcount' ); ?>"><?php echo __('Max number of albums', 'wp-symposium-gallery'); ?>:</label>
			<input id="<?php echo $this->get_field_id( 'albumcount' ); ?>" name="<?php echo $this->get_field_name( 'albumcount' ); ?>" value="<?php echo $instance['albumcount']; ?>" style="width: 30px" />
		</p>
		<?php
	}

}

/* ====================================================== HOOKS/FILTERS INTO WORDPRESS/WP SYMPOSIUM ====================================================== */

// Add plugin to WP Symposium admin menu via hook
function symposium_add_gallery_to_admin_menu()
{
	add_submenu_page('symposium_debug', __('Gallery', 'wp-symposium-gallery'), __('Gallery', 'wp-symposium-gallery'), 'edit_themes', 'wp-symposium-gallery/symposium_gallery_admin.php');
}
add_action('symposium_admin_menu_hook', 'symposium_add_gallery_to_admin_menu');

// ----------------------------------------------------------------------------------------------------------------------------------------------------------

// Add Menu item to Profile Menu through filter provided
// The menu picks up the id of div with id of menu_ (eg: menu_GALLERY) and will then run
// 'path-to/wp-symposium-GALLERY/ajax/symposium_GALLERY_functions.php' when clicked.
// It will pass $_POST['action'] set to menu_GALLERY to then be acted upon.
// See www.wpswiki.com for help

// ----------------------------------------------------------------------------------------------------------------------------------------------------------

function add_gallery_menu($html,$uid1,$uid2,$privacy,$is_friend,$extended,$share)  
{  
	global $current_user;

	if ( ($uid1 == $uid2) || (strtolower($privacy) == 'everyone') || (strtolower($privacy) == 'public') || (strtolower($privacy) == 'friends only' && $is_friend) || symposium_get_current_userlevel() == 5) {
  
		if ($uid1 == $uid2) {
			$html .= '<div id="menu_gallery" class="symposium_profile_menu">';
			$html .= __('My Gallery', 'wp-symposium-gallery'); 
			$html .= '</div>';  
		} else {
			$html .= '<div id="menu_gallery" class="symposium_profile_menu">';
			$html .= __('Gallery', 'wp-symposium-gallery'); 
			$html .= '</div>';  
		}
	}
	return $html;
}  
add_filter('symposium_profile_menu_filter', 'add_gallery_menu', 10, 7);

// ----------------------------------------------------------------------------------------------------------------------------------------------------------

// Add row to WPS installation page showing status of the Gallery plugin through hook provided
// install_row(
//	name, 
//	shortcode or '' if not application,
//	main plugin function, 
//	field in symposium_config holding page plugin has been added (eg: profile_url for profile page) or a '-' for none
//	relative path within plugins folder to plugin,
//	url for configuration or '',
//	message about where to install/download
// )
function symposium_installation_hook_gallery()
{
	install_row(
		__('Gallery', 'wp-symposium-gallery').' v'.get_option("symposium_gallery_version"), 
		'', 
		'symposium_gallery', 
		'-', 
		'wp-symposium-gallery/symposium-gallery.php', 
		'admin.php?page=wp-symposium-gallery/symposium_gallery_admin.php', 
		__('The Gallery plugin must be installed in ', 'wp-symposium-gallery').WP_PLUGIN_DIR.'/wp-symposium-gallery.'.chr(10).chr(10).'Download from http://www.wpsymposium.com/downloadinstall.'
	);

}
add_action('symposium_installation_hook', 'symposium_installation_hook_gallery');

// ----------------------------------------------------------------------------------------------------------------------------------------------------------

// Language files
if ( function_exists('load_plugin_textdomain') ) {
	load_plugin_textdomain( 'wp-symposium-gallery', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' );		
}


?>
